
//	Copyright 2010 PaletteSoft LLC

// ***************************************************************************
// *	dl															 *
// ***************************************************************************
/*
	XCb`ۃTv@						PIC12F683	CLOCK:INTRCIO/4MHz

	GP0:LED0	ώZ\_łŎ
	GP1:LED1	ԕ\_łŎ
	GP2:LED2	NA_łŎ
	GP3:MCLR	-----
	GP4:SW1		\iXCb`prŗ\j
	GP5:SW0		XCb`

	P̑XCb`ōƃ[h؂ւBN͐ώZ\ƂB

	ώZ\F	XCb`Itoԕ\ɐ؂ւB

	ԕ\F	ZmoώZ\ɐ؂ւB
				moNAɐ؂ւB

	NAF	XCb`Itoԕ\ɐ؂ւB

	XCb`Î܂ܑuNꍇ͐ώZ\ł͂邪AXCb`U
	ItȂƃXCb`ɂԑJڂ͊JnȂB

	XCb`̃`^O͖WRvŔfB
	XCb`ۂ̒o͖QAp͖TOOƂB
	kdc̓_ł͂PbԂɖTƂ
*/

// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************

#include	<pic.h>														//	vWFNgݒőIꂽfoCXIɈp܂

#include	"_AtrDef.h"													//	萔Af[^^̐錾
#include	"drvsw.h"													//	XCb`͔ėpCu

// ***************************************************************************
// *	vOo[W												 *
// ***************************************************************************

#define	VER1					0										//	ʏ\̈	PŎwip֎~j
#define	VER2					2										//	ʈ̈	PŎwip֎~j
//								.
#define	VER3					0										//	ʏ\̈	PŎwip֎~j
#define	VER4					1										//	ʈ̈	PŎwip֎~j

#define	COPYRIGHT				"Copyright 2010 PaletteSoft LLC"		//	쌠

// ***************************************************************************
// *																 *
// ***************************************************************************

	//	*****  *****

__CONFIG(	FCMDIS														//	tF[Z[tNbNj^֎~
		&	IESODIS														//	ONbÑXCb`I[o[[h֎~
		&	BORDIS														//	uEAEgo֎~
		&	UNPROTECT													//	f[^iEEPROMj̃veNg֎~
		&	UNPROTECT													//	vÕveNg֎~
		&	MCLREN														//	GP3/_MCLR[q_MCLRŗpiIɃvAbvj
		&	PWRTEN														//	p[Abv^C}싖
		&	WDTDIS														//	EHb`hbO^C}֎~
		&	INTIO														//	NbNpRA4ARA5[q͓o͂ŗp
);

	//	***** hc *****

__IDLOC7(VER1, VER2, VER3, VER4);										//	o[WԍƂĒ`ïӖt͔CӁj

// ***************************************************************************
// *	Œl																 *
// ***************************************************************************

	//	***** }lWg *****

enum {																	//	}lWg[h					@ԍĂ邾ł
	MNG_TRIP,															//	OFώZ\
	MNG_ODD,															//	PFԕ\
	MNG_CLEAR,															//	QFNA
	MNG_TOTAL															//	RF}lWg
} eMng;

#define	MNG_CYCLE				8192L									//	}lWgs				@W

	//	***** kdc *****

#define	MNG_LED_CYCLE			((1000000L / 10L) / MNG_CYCLE)			//	_Ŏ͂PbԂɂT				@[͐؂̂Ă܂

#define	MNG_LED_TRIP			(UB)BIT00								//	ώZ\pkdc\p^[
#define	MNG_LED_ODD				(UB)BIT01								//	ԕ\pkdc\p^[
#define	MNG_LED_CLEAR			(UB)BIT02								//	NApkdc\p^[

	//	***** XCb` *****

#define	PORT_SW0				(GPIO5)									//	XCb`O|[g
#define	PORT_SW1				(GPIO4)									//	XCb`P|[g					@͖gp

#define	SW_OPERATION			((size_sw)(BIT00))						//	XCb`

#define	SW_CHAT_NUMBER			3										//	`^O

#ifndef	SW_MINI															//	~j֐`ĂȂH
#define	SW_LONG_CYCLE			(UH)(2000000L / MNG_CYCLE)				//	oTCN͂POOO	@[͐؂̂ĂĂ܂
#define	SW_NEXT_CYCLE			(UH)( 500000L / MNG_CYCLE)				//	pTCŃ@TOO	@[͐؂̂ĂĂ܂
#endif

// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************

	//	***** }lWg *****

UB		vMngProc;														//	s}lWg

	//	***** XCb` *****

#ifndef	SW_MINI															//	~j֐`ĂȂH
sSwCht	vSwInf;															//	`^O
sSwAct	vSwAct;															//	ۊǗ
#endif

	//	***** kdc *****

UB		vLedData;														//	kdc_pf[^
UB		vLedTime;														//	kdc̓_Ő^C~O

// ***************************************************************************
// *	e[u															 *
// ***************************************************************************


// ***************************************************************************
// *	}N錾															 *
// ***************************************************************************


// ***************************************************************************
// *	vg^Cv錾													 *
// ***************************************************************************

	//	***** C *****

void	main(void);

void	MngTrip(UB Event);
void	MngTripInit(void);

void	MngOdd(UB Event);
void	MngOddInit(void);

void	MngClear(UB Event);
void	MngClearInit(void);

void	MngLedControl(void);
void	MngLedControlInit(void);

	//	***** foCX *****

void	DevInit(void);
size_sw	DevSwGet(void);
void	DevTmInit(void);

// ***************************************************************************
// *	{															 *
// ***************************************************************************

//	
//	
//
// 		C
//
//	
//	
void	Mng______(void) {}												//	op֐

//============================================================================
//	C
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	X^[gAbv[`̃Wv߂ŌĂяo܂B
//			{֐͖[vŏEo邱Ƃ͂܂B
//============================================================================
void	main(void)
{
	size_sw	NowSw;														//	XCb`̊m
	UB		SwEvent;													//	XCb`

	//	***** ͂߂ *****

	di();																//	Ă̊荞݋֎~𖾎

	DevInit();															//	foCXݒ

	//	***** }lWgݒ *****

#ifndef	SW_MINI															//	~j֐`ĂȂH
	DrvSwChtInit(&vSwInf, DevSwGet(), SW_CHAT_NUMBER);					//	`^O̏ݒ		@ɒ
	NowSw = DrvSwChtGetResult(&vSwInf);									//	XCb`̊m擾			@ɒ

	DrvSwActInit(&vSwAct, NowSw & SW_OPERATION,							//	XCb`ۂ̏ݒ				@ɒ
				 SW_LONG_CYCLE, SW_NEXT_CYCLE);							//							@ɒ
#else
	DrvSwChtInit(DevSwGet());											//	`^O̏ݒ		@ɒ
	NowSw = DrvSwChtGetResult();										//	XCb`̊m擾			@ɒ

	DrvSwActInit(NowSw & SW_OPERATION);									//	XCb`ۂ̏ݒ				@ɒ
#endif

	MngTripInit();														//	ώZ\}lWgI

	//	*****  *****

	DevTmInit();														//	^C}ݒ

	while (1) {															//	[vł

		//	***** ^CAEgmF *****

		if (T0IF) {														//	^C}OvH	c@荞ݗv͊荞݋֎~Lɂ炸
			T0IF = 0;													//	^C}Ov	c@ȉAW̎s^C~O

			//	***** XCb` *****

#ifndef	SW_MINI															//	~j֐`ĂȂH
			DrvSwChtUpdate(&vSwInf, DevSwGet());						//	XCb`̃`^O			@ɒ
			NowSw = DrvSwChtGetResult(&vSwInf);							//	XCb`̊m擾			@ɒ

			SwEvent = DrvSwActUpdate(&vSwAct, NowSw & SW_OPERATION);	//	XCb`ۂ̎擾					@ɒ
#else
			DrvSwChtUpdate(DevSwGet());									//	XCb`̃`^O			@ɒ
			NowSw = DrvSwChtGetResult();								//	XCb`̊m擾			@ɒ

			SwEvent = DrvSwActUpdate(NowSw & SW_OPERATION);				//	XCb`ۂ̎擾					@ɒ
#endif

			//	***** }lWg *****

			switch (vMngProc) {											//	݂̕\}lWgŕ

				case MNG_TRIP:											//	ώZ\
					MngTrip(SwEvent);
					break;

				case MNG_ODD:											//	ԕ\
					MngOdd(SwEvent);
					break;

				case MNG_CLEAR:											//	NA
					MngClear(SwEvent);
					break;
			}

			//	***** kdc_Ő *****

			MngLedControl();											//	kdc
		}
	}
}

//============================================================================
//	ώZ\
//----------------------------------------------------------------------------
//	́F	XCb`
//	óF	
//----------------------------------------------------------------------------
//	lF	ώZ\̃}lWgłB
//
//			͏ݒ葤łkdc̕\؂ւAXCb`ۂҋ@
//			܂B^pł̓XCb`ɉĐXVA\𓮓IɕύX
//			ƗlXȂƂs܂B
//============================================================================
void	MngTrip(UB Event)
{
	switch (Event) {													//	XCb`ۂŕ

		default:														//	̑
			;															//	ɖ
			break;

		case SW_ACT_SHORT:												//	Zm@c@XCb`Ito
		case SW_ACT_END:												//	I@c@XCb`Ito
			MngOddInit();												//	͋ԕ\}lWg
			break;
	}
}

void	MngTripInit(void)												//	ݒ
{
	vMngProc = MNG_TRIP;												//	}lWgԍݒ
	vLedData = MNG_LED_TRIP;											//	kdc\p^[ύX
}

//============================================================================
//	ԕ\
//----------------------------------------------------------------------------
//	́F	XCb`
//	óF	
//----------------------------------------------------------------------------
//	lF	ԕ\̃}lWgłB
//
//			͏ݒ葤łkdc̕\؂ւAXCb`ۂҋ@
//			܂B^pł̓XCb`ɉĐXVA\𓮓IɕύX
//			ƗlXȂƂs܂B
//============================================================================
void	MngOdd(UB Event)
{
	switch (Event) {													//	XCb`ۂŕ

		default:														//	̑
			;															//	ɖ
			break;

		case SW_ACT_SHORT:												//	Zm
			MngTripInit();												//	͐ώZ\}lWg
			break;

		case SW_ACT_LONG:												//	m
			MngClearInit();												//	̓NA}lWg
			break;
	}
}

void	MngOddInit(void)												//	ݒ
{
	vMngProc = MNG_ODD;													//	}lWgԍݒ
	vLedData = MNG_LED_ODD;												//	kdc\p^[ύX
}

//============================================================================
//	NA
//----------------------------------------------------------------------------
//	́F	XCb`
//	óF	
//----------------------------------------------------------------------------
//	lF	NÃ}lWgłB
//
//			͏ݒ葤łkdc̕\؂ւAXCb`ۂҋ@
//			܂B^pł̓XCb`ɉĐXVA\𓮓IɕύX
//			ƗlXȂƂs܂B
//============================================================================
void	MngClear(UB Event)
{
	switch (Event) {													//	XCb`ۂŕ

		default:														//	̑
			;															//	ɖ
			break;

		case SW_ACT_END:												//	I@c@XCb`Ito
			MngOddInit();												//	͋ԕ\}lWg
			break;
	}
}

void	MngClearInit(void)												//	ݒ
{
	vMngProc = MNG_CLEAR;												//	}lWgԍݒ
	vLedData = MNG_LED_CLEAR;											//	kdc\p^[ύX
}

//============================================================================
//	kdc
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	{֐͒ŎsAkdc̓_ł𐧌䂵܂B
//
//			͏o̓|[gR킪ĂkdcɊĂ̂ŁAI
//			|[gŜĂ܂B\łArbg
//			͔ĂBsꍇ̓obNAbvꂽ
//			CAobNAbvf[^ŏo̓|[gčXV@𐄏
//			܂B
//
//			_ł̐@͗lXłA͊ȒPȕ@ōς܂Ă܂B
//			͏ɏo̓|[gXVlɂ܂A̕@̌_̓I
//			ɂkdc\p^[ύXꂽꍇAɔfĂ܂
//			łB
//
//			̕\@ł͕ύXꂽ^C~OIԂZȂ̂ŁA
//			}~ꍇ́A
//			E^C~OQɂi̒ŃIPAItPjB
//			EϐƍXV\ϐmۂA̐؂ւڂŃRs[B
//			̐䂪KvłB̂́A쐬҂̗VjƎv
//			̂ŁA낢ȂĂ݂āAǂ_A_F
//			̃X^CgɂĂB
//============================================================================
void	MngLedControl(void)
{
	//	***** ^C~OXV *****

	if (++vLedTime >= ((UB)MNG_LED_CYCLE * 2)) {						//	^C~OXV𒴂H
		vLedTime = 0;													//	擪ɖ߂
	}

	//	***** kdc̐ *****										//	ɏo̓f[^XVP[X

	if (vLedTime < (UB)MNG_LED_CYCLE) {									//	It^C~OH
		GPIO = 0b00000000;												//	kdc𑍂ăIt
	}
	else {																//	I^C~O
		GPIO = vLedData;												//	݂̕\p^[o
	}
}

void	MngLedControlInit(void)											//	ݒ
{
	vLedTime = 0;														//	_Ő^C~ONA
}

//	
//	
//
// 		foCX
//
//	
//	
void	Dev______(void) {}												//	op֐

//============================================================================
//	foCXݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	foCX̏ݒs܂B
//			Zbg̏lōςޏꍇ͍Đݒ肵Ă܂B
//============================================================================
void	DevInit(void)
{
	//	***** { *****

//						  76543210
	OPTION =			0b01111111;										//	IvVWX^
																		//	bit07:GPPU		0	̓|[g̃vAbv			
																		//	bit06:INTEDG	1	O荞݂͗オGbW		gp
																		//	bit05:T0CS		1	^C}O͊ONbN𗘗p		gp
																		//	bit04:T0SE		1	^C}O̍XV͗GbW		gp
																		//	bit03:PSA		1	vXP[͂vcsŗp			gp
																		//	bit02:PS2		1	vXP[͂PQW			gp
																		//	bit01:PS1		1		ij
																		//	bit00:PS0		1		ij

	//	***** o̓|[g *****										//	ӁFĂ̏ꍇAėpo̓|[g͕ʋ@\Ă

//						  76543210
	GPIO			 =	0b00000000;										//	ėpo̓|[gf[^̏l
																		//	bit07:-----		0
																		//	bit06:-----		0
																		//	bit05:GP5		0	́FrvO						͂Ȃ̂ŖӖ
																		//	bit04:GP4		0	́FrvP						͂Ȃ̂ŖӖ
																		//	bit03:GP3		0	́Flbkq						w͖
																		//	bit02:GP2		0	óFkdcQ						
																		//	bit01:GP1		0	óFkdcP						
																		//	bit00:GP0		0	óFkdcO						

//						  76543210
	CMCON0 =			0b00000111;										//	Rp[^
																		//	bit07:-----		0
																		//	bit06:COUT		0	Rp[^o͏				ǂݏô݉
																		//	bit05:-----		0
																		//	bit04:CINV		0	o͔]Ȃ						gp
																		//	bit03:CIS		0	̓XCb`ݒ					gp
																		//	bit02:CM2		1	Rp[^It					
																		//	bit01:CM1		1		ij						
																		//	bit00:CM0		1		ij						

//						  76543210
	ANSEL =				0b00000000;										//	AiOZN^
																		//	bit07:-----		0
																		//	bit06:ADCS2		0	`cϊNbNI				gp
																		//	bit05:ADCS1		0		ij
																		//	bit04:ADCS0		0		ij
																		//	bit03:ANS3		0	`mRgpAfoSėpo		
																		//	bit02:ANS2		0	`mQgpAfoQėpo		
																		//	bit01:ANS1		0	`mPgpAfoPėpo		
																		//	bit00:ANS0		0	`mOgpAfoOėpo		

//						  76543210
	TRISIO =			0b00111000;										//	ėpo̓|[g
																		//	bit07:-----		0
																		//	bit06:-----		0
																		//	bit05:GP5		1	́FrvO						
																		//	bit04:GP4		1	́FrvP						
																		//	bit03:GP3		1	́Flbkq						ǂݏô݉
																		//	bit02:GP2		0	óFkdcQ						
																		//	bit01:GP1		0	óFkdcP						
																		//	bit00:GP0		0	óFkdcO						
}

//============================================================================
//	XCb`̏Ԏ擾
//----------------------------------------------------------------------------
//	́F	
//	óF	XCb`̏
//----------------------------------------------------------------------------
//	lF	XCb`݂̌̏Ԃ擾܂B
//============================================================================
size_sw	DevSwGet(void)
{
	size_sw	Result = 0;													//	XCb`ItԂŏݒ

	if (PORT_SW0 == 0) {												//	XCb`O̓IH
		Result |= SW_OPERATION;											//	XCb`ÕIZbg
	}

	return(Result);														//	XCb`̏ԂԂ܂
}

//============================================================================
//	^C}ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	^C}Ȍݒs܂B
//			USlgARQɂWPXQʂŃ^CAEg܂B
//============================================================================
void	DevTmInit(void)
{
	//	***** ^C}Õ[hݒ *****

	CLRWDT();															//	vcs̃tbV	c@ʓIɓ삵ĂȂ̂Ōʖ
																		//								f[^V[gɋLڂĂ@𓥏P
//						 76543210	   76543210
	OPTION = (OPTION & 0b11010000) | 0b00000100;						//	IvVWX^		c@ݒς݂̒lC
																		//	bit07:GPPU		*	iύXȂj
																		//	bit06:INTEDG	*	iύXȂj
																		//	bit05:T0CS		0	^C}O͓NbN𗘗p		
																		//	bit04:T0SE		*	iύXȂj
																		//	bit03:PSA		0	vXP[̓^C}Oŗp		
																		//	bit02:PS2		1	vXP[͂RQ				
																		//	bit01:PS1		0		ij
																		//	bit00:PS0		0		ij

	//	***** ^C}Õ^CAEg󋵂 *****

	TMR0 = 0;															//	^C}OJE^̃NAivXP[ɃNAj
	T0IE = 0;															//	^C}O͋֎~
	T0IF = 0;															//	^C}Ov	c@slqOWX^̃I[o[t[
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC

